#
# Copyright © 2020 MSC.Software Corporation
#  
# Permission to use Scripts
#  
# Permission is granted to MSC.Software customers with valid licenses of the MSC Apex™ software 
# to use script files posted on this page (collectively “Scripts”) solely for customers’ own authorized 
# internal use in conjunction with licensed use of the MSC Apex software.  
# No other use is permitted.  No license to MSC Apex or other software is granted under this Permission.
#  
# SCRIPTS ARE PROVIDED ON AN "AS-IS" BASIS, WITH NO WARRANTIES OF ANY KIND.  USE OF THE SCRIPTS IS AT CUSTOMER'S SOLE RISK.
#  
# IN NO EVENT SHALL MSC.SOFTWARE CORPORATION, ITS AFFILIATES, SUBSIDIARIES, SUPPLIERS, AGENTS, REPRESENTATIVES OR EMPLOYEES BE LIABLE FOR ANY 
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, TORT, 
# STRICT LIABILITY, OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION USE OF THE SCRIPTS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
#  
# Customer shall indemnify, defend and hold MSC.Software Corporation, its affiliates, subsidiaries, suppliers, agents, 
# employees or representatives (collectively, “Indemnified Parties”) harmless from and against any third-party claims 
# brought against Indemnified Parties rising out of or in connection with Customer’s use of the Scripts.
#
import sys
import os
import apex_sdk
import clr

#.NET references
import System
import System.Windows.Controls as WPFControls
from System.Windows.Automation import AutomationProperties
from Microsoft.Win32 import OpenFileDialog



#setting pre-defined properties of tool_propertyContainer
def getUIContent():
	my_toolProperty = apex_sdk.ToolPropertyContainer()

	my_toolProperty.TitleText = "Define Loadsteps"

	file_path = os.path.dirname(os.path.realpath(__file__))
	my_toolProperty.TitleImageUriString = os.path.dirname(file_path) + './res/setupStudy.png'


	my_toolProperty.WorkFlowInstructions = """<HTML><BODY><P STYLE=\"font-size:10;\"><SPAN>Identifies CAD Bolts and creates 1d connectors.</SPAN></P>
	<P><SPAN> </SPAN></P>
	<P STYLE=\"font-size:10;\"><SPAN>
	Setup Study with User Defined Names
	</SPAN></P>
	<P><SPAN> </SPAN></P>
	<P STYLE=\"font-size:10;\"><SPAN>Send questions, comments to stefan.tynelius@hexagon.com <br>
	Elvis sightings are as usual reported to larry.pearce@hexagon.com</SPAN></P></BODY></HTML>"""



	#handle apply button (green) click event
	my_toolProperty.AppliedCommand = apex_sdk.ActionCommand(System.Action(HandleApplyButton))
	# handle exit button (red) click event
	my_toolProperty.ExitCommand = apex_sdk.ActionCommand(System.Action(HandleExitButton))

	my_toolProperty.ToolPropertyContent = getCustomToolPropertyContent()

	#define pickFiterTools
	my_toolProperty.ShowPickChoice = True
	my_toolProperty.IsCustomTool = True
	#setPickFilterTools()
	my_toolProperty.PickFilterList = setPickFilterTools()

	return my_toolProperty

def getCustomToolPropertyContent():

	my_Grid = WPFControls.Grid()

	createLayout(my_Grid, 20, 2)
	col=0
	row = 1

	# try:
		# defaulttemperatureLoad=SettingsD['NASTRAN_JOB_SETUP']['SOL400DefaulttemperatureLoad'].upper()
		# if defaulttemperatureLoad != "GLUE":
			# defaulttemperatureLoad="TOUCH"
		# else:
			# defaulttemperatureLoad="GLUE"

	# except:
		# defaulttemperatureLoad="GLUE"


	# try:
		# default_TouchingContactError=float(SettingsD['NASTRAN_JOB_SETUP']['SOL400TouchingContactError'])
	# except:
		# default_TouchingContactError=0.1

	# try:
		# default_GlueContactError=float(SettingsD['NASTRAN_JOB_SETUP']['SOL400GlueContactError'])
	# except:
		# default_GlueContactError=0.5	

	try:
		init_temp=float(SettingsD['NASTRAN_JOB_SETUP']['InitialTemperature'])
	except:
		init_temp=20

	global stepNameTextBox,  stepNameTextBlock
	stepNameTextBox, stepNameTextBlock= createDataBox(my_Grid, "Analysis Name", "Analysis 1" , row, col)

	stepNameTextBox.Visibility = System.Windows.Visibility.Visible
	stepNameTextBlock.Visibility       = System.Windows.Visibility.Visible

	row += 1

	#global initialTemperatureTextBox,  initialTemperatureTextBlock
	#initialTemperatureTextBox, initialTemperatureTextBlock= createDataBox(my_Grid, "Initial Temperature", str(init_temp) , row, col)

	#initialTemperatureTextBox.Visibility = System.Windows.Visibility.Visible
	#initialTemperatureTextBlock.Visibility       = System.Windows.Visibility.Visible
	#row += 1

	#createEmptyRow(my_Grid, row)
	#row += 1	

	global eventNameTextBox,  eventNameTextBlock
	eventNameTextBox, eventNameTextBlock= createDataBox(my_Grid, "Event Name", "Event" , row, col)
	eventNameTextBox.Visibility = System.Windows.Visibility.Visible
	eventNameTextBlock.Visibility       = System.Windows.Visibility.Visible

	row += 1


	# global temperatureLoadTextBox,  temperatureLoadComboBox
	# temperatureLoadComboBox, temperatureLoadTextBox = createComboBox(my_Grid, "Temperature Load Step:", ["Yes", "No"], 1, row, col)

	# row += 1
	# #choices = temperatureLoadComboBox.SelectedValue.ToString().split(":")
	# #choice = choices[len(choices)-1].lstrip().rstrip()
	# #
	# temperatureLoadComboBox.SelectionChanged += temperatureLoadComboBoxCB

	# temperatureLoadTextBox.Visibility = System.Windows.Visibility.Visible
	# temperatureLoadComboBox.Visibility    = System.Windows.Visibility.Visible




	# global temperatureTextBox,  temperatureTextBlock
	# temperatureTextBox, temperatureTextBlock= createDataBox(my_Grid, "Event Temperature", "20." , row, col)

	# temperatureTextBox.Visibility = System.Windows.Visibility.Collapsed
	# temperatureTextBlock.Visibility       = System.Windows.Visibility.Collapsed
	# row += 1

	#WPFControls.Grid.SetColumnSpan(addEventsTextBox, 2)

	addEventBtn = WPFControls.Button()
	addEventBtn.Content="Add Event"

	#WPFControls.Grid.SetColumnSpan(addEventBtn, 2)

	WPFControls.Grid.SetRow(addEventBtn, row)
	WPFControls.Grid.SetColumn(addEventBtn, col)

	#Link a function to the Button "Click" event 
	#This function will be called every time the Button is clicked
	addEventBtn.Click+=HandleAddEventBtn

	# Add the controls to the Grid
	my_Grid.Children.Add(addEventBtn)	
	row += 1	

	return my_Grid


# def temperatureLoadComboBoxCB(sender, event):
	# # I need to learn and understand sender and event
	# global temperatureLoadComboBox
	# global temperatureTextBox, temperatureTextBlock

	# choices = temperatureLoadComboBox.SelectedValue.ToString().split(":")
	# choice = choices[len(choices)-1].lstrip().rstrip()

	# if choice == "Yes":
		# temperatureTextBox.Visibility       = System.Windows.Visibility.Visible
		# temperatureTextBlock.Visibility         = System.Windows.Visibility.Visible

	# else:
		# temperatureTextBox.Visibility       = System.Windows.Visibility.Collapsed
		# temperatureTextBlock.Visibility         = System.Windows.Visibility.Collapsed

def createLayout(parent, numRows, numCols):
	for k in range(numRows):
		parent.RowDefinitions.Add(WPFControls.RowDefinition())
	for k in range(numCols):
		parent.ColumnDefinitions.Add(WPFControls.ColumnDefinition())


def createComboBox(parent, title, labels, selected, row, col):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = title
	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, col)

	parent.Children.Add(textBlock)

	comboBox = WPFControls.ComboBox()
	for label in labels:
		item = WPFControls.ComboBoxItem()
		item.Content=label
		comboBox.Items.Add(item)

	WPFControls.Grid.SetRow(comboBox, row)
	WPFControls.Grid.SetColumn(comboBox, col+1)

	if selected > len(labels): selected = 0
	comboBox.SelectedIndex=str(selected)

	parent.Children.Add(comboBox)

	return comboBox, textBlock


def updateComboBox(comboBox, comboItems):

	for comboItem in comboItems:
		item = WPFControls.ComboBoxItem()
		item.Content=comboItem
		comboBox.Items.Add(item)

	comboBox.SelectedIndex="0"

def createTextBlock(parent, text, row, col):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = text

	textBlock.Margin = System.Windows.Thickness(5.)

	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, col)
	parent.Children.Add(textBlock)

	return textBlock


def createTextBox(parent, value, row, col):
	textBox =WPFControls.TextBox()

	textBox.Margin = System.Windows.Thickness(5.)

	WPFControls.Grid.SetRow(textBox, row)
	WPFControls.Grid.SetColumn(textBox, col)
	textBox.Text=value

	parent.Children.Add(textBox)

	return textBox


def createDataBox(parent, title, value, row, col):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = title
	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, col)

	textBox =WPFControls.TextBox()
	WPFControls.Grid.SetRow(textBox, row)
	WPFControls.Grid.SetColumn(textBox, col+1)
	textBox.Text=value

	parent.Children.Add(textBlock)
	parent.Children.Add(textBox)

	return textBox,textBlock

def createCheckBox(parent, title, active, row, col):
	myWrapPanel = WPFControls.WrapPanel()
	myWrapPanel.Orientation = WPFControls.Orientation.Vertical

	CheckBox = WPFControls.CheckBox()
	CheckBox.Content = title
	myWrapPanel.Children.Add(CheckBox)

	WPFControls.Grid.SetRow(myWrapPanel, row)
	WPFControls.Grid.SetColumn(myWrapPanel, col)
	CheckBox.IsChecked = System.Nullable[System.Boolean](active)

	parent.Children.Add(myWrapPanel)

	return CheckBox


def createDataBox2(parent, value, row, col):
	textBox =WPFControls.TextBox()
	WPFControls.Grid.SetRow(textBox, row)
	WPFControls.Grid.SetColumn(textBox, col)
	textBox.Text=value

	parent.Children.Add(textBox)

	return textBox

def createEmptyRow(parent, row):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = ""
	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, 0)

	parent.Children.Add(textBlock)

	return


#set pickFilers
#some pick choices are commented out
def setPickFilterTools():
	pickChoices = System.Collections.Generic.List[System.String]()

	#exclusive picking and visibility picking	
	pickChoices.Add(apex_sdk.PickFilterTypes.ExclusivePicking)
	pickChoices.Add(apex_sdk.PickFilterTypes.VisibilityPicking)

	#Assembly and part
	#pickChoices.Add(apex_sdk.PickFilterTypes.Assembly)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Part)

	#Bodies	
	#pickChoices.Add(apex_sdk.PickFilterTypes.SolidMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Solid)
	#pickChoices.Add(apex_sdk.PickFilterTypes.SurfaceMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Surface)
	#pickChoices.Add(apex_sdk.PickFilterTypes.CurveMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Curve)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Point)

	#features
	#pickChoices.Add(apex_sdk.PickFilterTypes.CellMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.FaceMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EdgeMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Cell)
	#pickChoices.Add(apex_sdk.PickFilterTypes.VertexMesh)

	#Lower Dimensional Entities
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element3D)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element2D)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Face)
	#pickChoices.Add(apex_sdk.PickFilterTypes.MeshSeed)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element1D)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Edge)
	#pickChoices.Add(apex_sdk.PickFilterTypes.SeedPoint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Node)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Vertex)

	#Sub Lower Dimensional Entities
	#pickChoices.Add(apex_sdk.PickFilterTypes.ElementEdge)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ElementFace)

	#Interactions and connections
	#pickChoices.Add(apex_sdk.PickFilterTypes.DiscreteTie)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Connector)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EdgeTie)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Joint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Glue)
	#LBCs
	#pickChoices.Add(apex_sdk.PickFilterTypes.Pressure)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Gravity)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Constraint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ForceMoment)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EnforcedMotion)

	#Attributes and other objects
	#pickChoices.Add(apex_sdk.PickFilterTypes.CompositeZone)
	#pickChoices.Add(apex_sdk.PickFilterTypes.LayeredPanel)
	#pickChoices.Add(apex_sdk.PickFilterTypes.InterfacePoint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.PointMass)
	#pickChoices.Add(apex_sdk.PickFilterTypes.BeamSpan)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Offset)

	#Sensors
	#pickChoices.Add(apex_sdk.PickFilterTypes.MotionEnvelopeSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ClearanceSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.CrossSectionSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.PointSensor)

	#Coordinate system
	#pickChoices.Add(apex_sdk.PickFilterTypes.CoordinateSystem)

	#Tool Registration
	#Tool Name has to be the same
	#apex_sdk.PickFilterRegistration.RegisterTool("Auto Tie Nodes", pickChoices)
	return pickChoices

#Function to handle the Import Button "Click" event
#This function gets called every time the Button is clicked
@apex_sdk.errorhandler
def HandleAddEventBtn(sender,args):

	dictionary={}
	dictionary["stepName"] = stepNameTextBox.Text
	dictionary["eventName"] = eventNameTextBox.Text
	dictionary["eventName"] = eventNameTextBox.Text
	#dictionary["initTemp"]=initialTemperatureTextBox.Text

	#choices = temperatureLoadComboBox.SelectedValue.ToString().split(":")
	#choice = choices[len(choices)-1].lstrip().rstrip()
	#dictionary["tempLoadCase"] = choice
	#dictionary["temp"] = temperatureTextBox.Text

	file_path = os.path.dirname(os.path.realpath(__file__))
	script_path= os.path.join(file_path, 'addEvents.py')
	#apex_sdk.runScriptFunction(script_path, "main", dictionary, callback=highlightBodies)
	apex_sdk.runScriptFunction(script_path, "main", dictionary)

@apex_sdk.errorhandler
def HandleApplyButton():
	# Create a Dictionary to store the user defined tool data  
	# dictionary = {}

	# choices = temperatureLoadComboBox.SelectedValue.ToString().split(":")
	# choice = choices[len(choices)-1].lstrip().rstrip()
	# dictionary["temperatureLoad"] = choice

	# dictionary["TouchTol"] = defaultTouchingTolTextBox.Text
	# dictionary["GlueTol"] = stepNameTextBox.Text
	# dictionary["Friction"] = defaultFrictTextBox.Text
	# dictionary["Bias"] = biasTextBox.Text

	# file_path = os.path.dirname(os.path.realpath(__file__))
	# script_path= os.path.join(file_path, 'editContacts.py')

	# apex_sdk.runScriptFunction(script_path, "main", dictionary)
	return


# exit button (red) from tool header
@apex_sdk.errorhandler
def HandleExitButton():
	print("HandleExitButton")
	file_path = os.path.dirname(os.path.realpath(__file__))
	script_path= os.path.join(file_path, 'editContacts.py')
	# Create a Dictionary to store the user defined tool data  
	dictionary = {}

	#choices = frameTypeComboBox.SelectedValue.ToString().split(":")
	#choice = choices[len(choices)-1].lstrip().rstrip()

	apex_sdk.runScriptFunction(script_path, "exectuteOnExit", dictionary)